package com.moyoung.moyoung_ble_plugin.conn;

import android.util.Log;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.listener.CRPFileTransListener;
import com.moyoung.moyoung_ble_plugin.base.BaseConnEveChlHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.conn.model.ContactBean;
import com.moyoung.moyoung_ble_plugin.conn.model.FileTransLazyBean;

import java.util.HashMap;
import java.util.Map;

import io.flutter.plugin.common.MethodCall;

class ContactAvatarLazyHandler extends BaseConnEveChlHandler {
    Map<String, Object> mapStr = new HashMap<>();
    private final static String TAG = ContactAvatarLazyHandler.class.getSimpleName();

    @Override
    public void setConnListener(CRPBleConnection connection, MethodCall call) {
        String jsonStr = call.argument("contactBean");
        Log.d(TAG, jsonStr);
        ContactBean contactBean = GsonUtils.get().fromJson(jsonStr, ContactBean.class);
        connection.sendContactAvatar(contactBean.getId(),  contactBean.getAvatar(),
                contactBean.getTimeout(),  new CRPFileTransListener() {
            @Override
            public void onTransProgressStarting() {
                FileTransLazyBean transLazy = new FileTransLazyBean();
                transLazy.setProgress(0);
                String jsonStr = GsonUtils.get().toJson(transLazy, FileTransLazyBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }

            @Override
            public void onTransProgressChanged(int progress) {
                FileTransLazyBean transLazy = new FileTransLazyBean();
                transLazy.setProgress(progress);
                String jsonStr = GsonUtils.get().toJson(transLazy, FileTransLazyBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }

            @Override
            public void onTransCompleted() {
                FileTransLazyBean transLazy = new FileTransLazyBean();
                transLazy.setProgress(100);
                String jsonStr = GsonUtils.get().toJson(transLazy, FileTransLazyBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }

            @Override
            public void onError(int error) {
                FileTransLazyBean transLazy = new FileTransLazyBean();
                transLazy.setError(error);
                String jsonStr = GsonUtils.get().toJson(transLazy, FileTransLazyBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }
        });
    }

}

