package com.moyoung.moyoung_ble_plugin.conn;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.listener.CRPDeviceBatteryListener;
import com.moyoung.moyoung_ble_plugin.base.BaseConnEveChlHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.conn.model.ContactListenBean;
import com.moyoung.moyoung_ble_plugin.conn.model.DeviceBatteryBean;

import java.util.HashMap;
import java.util.Map;

import io.flutter.plugin.common.MethodCall;

class DeviceBatteryHandler extends BaseConnEveChlHandler {
    @Override
    public void setConnListener(CRPBleConnection connection, MethodCall call) {
        Map<String, Object> mapStr = new HashMap<>();
        connection.setDeviceBatteryListener(new CRPDeviceBatteryListener() {
            @Override
            public void onSubscribe(boolean enable) {
                DeviceBatteryBean device = new DeviceBatteryBean();
                device.setEnable(enable);
                String jsonStr = GsonUtils.get().toJson(device, DeviceBatteryBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }

            @Override
            public void onDeviceBattery(int deviceBattery) {
                DeviceBatteryBean device = new DeviceBatteryBean();
                device.setDeviceBattery(deviceBattery);
                String jsonStr = GsonUtils.get().toJson(device, DeviceBatteryBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }
        });
    }

}

