package com.moyoung.moyoung_ble_plugin.conn;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.listener.CRPBleECGChangeListener;
import com.crrepa.ble.conn.type.CRPEcgMeasureType;
import com.moyoung.moyoung_ble_plugin.base.BaseConnEveChlHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.conn.model.ECGBean;

import java.util.Date;

import io.flutter.plugin.common.MethodCall;

class ECGHandler extends BaseConnEveChlHandler {
    @Override
    public void setConnListener(CRPBleConnection connection, MethodCall call) {
        String ecgMeasureType = call.argument("ecgMeasureType");
        ecgMeasureType = ecgMeasureType == null ? CRPEcgMeasureType.TI.toString() : ecgMeasureType;
        
        connection.setECGChangeListener(new CRPBleECGChangeListener() {
            @Override
            public void onECGChange(int[] ECGChangeInts) {
                ECGBean ECGBean = new ECGBean(true);
                ECGBean.setInts(ECGChangeInts);
                String egcStr = GsonUtils.get().toJson(ECGBean, ECGBean.class);
                activity.runOnUiThread(() -> eventSink.success(egcStr));
            }

            @Override
            public void onMeasureComplete() {
                ECGBean ECGBean = new ECGBean(true);
                ECGBean.setMeasureComplete(100);
                String egcStr = GsonUtils.get().toJson(ECGBean, ECGBean.class);
                activity.runOnUiThread(() -> eventSink.success(egcStr));
            }

            @Override
            public void onTransCpmplete(Date date) {
                ECGBean ECGBean = new ECGBean(true);
                ECGBean.setDate(date);
                String egcStr = GsonUtils.get().toJson(ECGBean, ECGBean.class);
                activity.runOnUiThread(() -> eventSink.success(egcStr));
            }

            @Override
            public void onCancel() {
                ECGBean ECGBean = new ECGBean(true);
                ECGBean.setCancel(true);
                String egcStr = GsonUtils.get().toJson(ECGBean, ECGBean.class);
                activity.runOnUiThread(() -> eventSink.success(egcStr));
            }

            @Override
            public void onFail() {
                ECGBean ECGBean = new ECGBean(true);
                ECGBean.setFail(true);
                String egcStr = GsonUtils.get().toJson(ECGBean, ECGBean.class);
                activity.runOnUiThread(() -> eventSink.success(egcStr));
            }
        }, CRPEcgMeasureType.valueOf(ecgMeasureType));
    }
}

