package com.moyoung.moyoung_ble_plugin.conn;

import android.app.Activity;
import android.util.Log;

import com.crrepa.ble.conn.listener.CRPBleFirmwareUpgradeListener;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.conn.model.ContactListenBean;
import com.moyoung.moyoung_ble_plugin.conn.model.FirmwareUpgradeBean;

import java.util.HashMap;
import java.util.Map;

import io.flutter.plugin.common.EventChannel;

public class FirmwareUpgradeListener implements CRPBleFirmwareUpgradeListener {
    Map<String, Object> mapStr = new HashMap<>();
    protected EventChannel.EventSink eventSink;
    protected Activity activity;

    public FirmwareUpgradeListener(EventChannel.EventSink eventSink, Activity activity) {
        this.eventSink = eventSink;
        this.activity = activity;
    }

    @Override
    public void onFirmwareDownloadStarting() {

    }

    @Override
    public void onFirmwareDownloadComplete() {

    }

    @Override
    public void onUpgradeProgressStarting() {

    }

    @Override
    public void onUpgradeProgressChanged(int OTAProgressInt, float OTAProgressFloat) {
        FirmwareUpgradeBean firmwareUpgrade = new FirmwareUpgradeBean();
        firmwareUpgrade.setOTAProgressInt(OTAProgressInt);
        firmwareUpgrade.setOTAProgressFloat(OTAProgressFloat);
        String jsonStr = GsonUtils.get().toJson(firmwareUpgrade, FirmwareUpgradeBean.class);
        Log.i("-------", "onUpgradeProgressChanged: " + jsonStr);
        activity.runOnUiThread(() -> eventSink.success(jsonStr));
    }

    @Override
    public void onUpgradeCompleted() {

    }

    @Override
    public void onUpgradeAborted() {

    }

    @Override
    public void onError(int error, String errorContent) {
        FirmwareUpgradeBean firmwareUpgrade = new FirmwareUpgradeBean();
        firmwareUpgrade.setError(error);
        firmwareUpgrade.setErrorContent(errorContent);
        String jsonStr = GsonUtils.get().toJson(firmwareUpgrade, FirmwareUpgradeBean.class);
        Log.i("-------", "onError: " + jsonStr);
        activity.runOnUiThread(() -> eventSink.success(jsonStr));
    }
}
