package com.moyoung.moyoung_ble_plugin.conn;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.bean.CRPTempInfo;
import com.crrepa.ble.conn.listener.CRPTempChangeListener;
import com.moyoung.moyoung_ble_plugin.base.BaseConnEveChlHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.conn.model.TempChangeBean;

import io.flutter.plugin.common.MethodCall;

public class TempChangeHandler extends BaseConnEveChlHandler {
    TempChangeBean bean = new TempChangeBean();
    @Override
    public void setConnListener(CRPBleConnection connection, MethodCall call) {
        connection.setTempChangeListener(new CRPTempChangeListener() {
            public void onContinueState(boolean enable) {

                bean.setEnable(enable);
                String jsonStr = GsonUtils.get().toJson(bean,TempChangeBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }

            public void onMeasureTemp(float temp) {
                bean.setTemp(temp);
                String jsonStr = GsonUtils.get().toJson(bean,TempChangeBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }

            public void onMeasureState(boolean state) {
                bean.setState(state);
                String jsonStr = GsonUtils.get().toJson(bean,TempChangeBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }

            public void onContinueTemp(CRPTempInfo tempInfo) {
                bean.setTempInfo(tempInfo);
                String jsonStr = GsonUtils.get().toJson(bean,TempChangeBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }
        });
    }
}
