import 'dart:async';

import 'package:flutter/material.dart';
import 'package:logger/logger.dart';

import 'package:moyoung_ble_plugin_example/lbz.dart';
import 'package:moyoung_ble_plugin_example/quickView.dart';
import 'package:moyoung_ble_plugin_example/sedentaryReminder.dart';
import 'package:moyoung_ble_plugin_example/shutDown.dart';
import 'package:moyoung_ble_plugin_example/sleep.dart';
import 'package:moyoung_ble_plugin_example/steps.dart';
import 'package:moyoung_ble_plugin_example/takePhoto.dart';
import 'package:moyoung_ble_plugin_example/time.dart';
import 'package:moyoung_ble_plugin_example/unitsystem.dart';
import 'package:moyoung_ble_plugin_example/userInfo.dart';
import 'package:moyoung_ble_plugin_example/watchFace.dart';
import 'package:moyoung_ble_plugin_example/weather.dart';
import 'package:moyoung_ble_plugin_example/xulei.dart';
import 'package:moyoung_ble_plugin_example/yusixia.dart';

import 'package:moyoung_ble_plugin/moyoung_ble.dart';

import 'BloodOxygen.dart';
import 'ECG.dart';
import 'FindWatch.dart';
import 'Language.dart';
import 'MusicPlayer.dart';
import 'RSSI.dart';
import 'alarm.dart';
import 'battery.dart';
import 'bloodPressurePage.dart';
import 'breathingLight.dart';
import 'drinkWaterReminder.dart';
import 'findPhone.dart';
import 'firmware.dart';
import 'goalSteps.dart';
import 'heartRate.dart';
import 'heartRateAlarm.dart';
import 'menstrualCycle.dart';
import 'notDisturb.dart';
import 'notification.dart';

class NewRoute extends StatefulWidget {
  BleScanBean device;

  NewRoute({
    Key? key,
    required this.device,
  }) : super(key: key);

  @override
  State<StatefulWidget> createState() {
    return _NewRoute(device);
  }
}

class _NewRoute extends State<NewRoute> {
  late BleScanBean device;

  final _streamSubscriptions = <StreamSubscription<dynamic>>[];
  // final MoyoungBlePlugin _blePlugin = MoyoungBlePlugin();
  final MoYoungBle _blePlugin = MoYoungBle();


  int _connetionState = -1;
  StepChangeBean _connStepChange =
  StepChangeBean(stepInfo: StepChange(steps: -1, distance: -1, calories: -1, time: -1),past:-1,
          pastStepInfo:StepChange(steps: -1, distance: -1, calories: -1, time: -1));
  bool isConn = false;

  //余诗霞：start
  Logger logger = Logger();
  String oTAType="";
  //余诗霞：end

  _NewRoute(this.device);

  @override
  void initState() {
    super.initState();
    subscriptStream();
  }

  void subscriptStream() {
    _streamSubscriptions.add(
      _blePlugin.connStateEveStm.listen(
        (int event) {
          setState(() {
            _connetionState = event;
          });
        },
      ),
    );

    _streamSubscriptions.add(
      _blePlugin.stepsChangeEveStm.listen(
        (StepChangeBean event) {
          setState(() {
            logger.d(_connStepChange.stepInfo.steps.toString());
          });
        },
      ),
    );

    //余诗霞补充

    _streamSubscriptions.add(
      _blePlugin.deviceBatteryEveStm.listen(
        (DeviceBatteryBean event) {
          setState(() {
            // _connStepChange = event;
          });
        },
      ),
    );

    _streamSubscriptions.add(
      _blePlugin.weatherChangeEveStm.listen(
        (int event) {
          setState(() {
            // _connStepChange = event;
          });
        },
      ),
    );

    _streamSubscriptions.add(
      _blePlugin.stepsCategoryEveStm.listen(
        (StepsCategoryBean event) {
          setState(() {
            // _connStepChange = event;
          });
        },
      ),
    );
    _streamSubscriptions.add(
      _blePlugin.sleepChangeEveStm.listen(
        (SleepBean event) {
          setState(() {
            // _connStepChange = event;
          });
        },
      ),
    );
    _streamSubscriptions.add(
      _blePlugin.firmwareUpgradeEveStm.listen(
        (FirmwareUpgradeBean event) {
          setState(() {
            // _connStepChange = event;
          });
        },
      ),
    );


    //余诗霞：start
    _streamSubscriptions.add(
      _blePlugin.heartRateEveStm.listen(
        (event) {
          setState(() {
            logger.d('connHeartRateEveStm===' + event.measuring.toString());
          });
        },
      ),
    );
    _streamSubscriptions.add(
      _blePlugin.bloodPressureEveStm.listen(
        (event) {
          setState(() {
            logger.d('connBloodPressureEveStm===' + event.bloodPressureChange.toString());
          });
        },
      ),
    );
    _streamSubscriptions.add(
      _blePlugin.bloodOxygenEveStm.listen(
        (event) {
          setState(() {
            logger.d('connBloodOxygenEveStm===' + event.bloodOxygen.toString());
          });
        },
      ),
    );
    _streamSubscriptions.add(
      _blePlugin.cameraEveStm.listen(
        (event) {
          setState(() {
            logger.d('connCameraEveStm');
          });
        },
      ),
    );
    _streamSubscriptions.add(
      _blePlugin.phoneEveStm.listen(
        (event) {
          setState(() {
            logger.d('connPhoneEveStm===' + event.toString());
          });
        },
      ),
    );
    _streamSubscriptions.add(
      _blePlugin.deviceRssiEveStm.listen(
        (event) {
          setState(() {
            logger.d('connDeviceRssiEveStm===' + event.toString());
          });
        },
      ),
    );

    var lazyFileTransEveStm = _blePlugin.lazyFileTransEveStm.listen(
          (WatchFaceBgProgressBean event) {
        setState(() {
          logger.d('connLazyFileTransEveStm===' + event.toString());
        });
      },
    );
    lazyFileTransEveStm.onError((error) {
      print(error.toString());
    });
    _streamSubscriptions.add(lazyFileTransEveStm);

    _streamSubscriptions.add(
      _blePlugin.lazyWFFileTransEveStm.listen(
        (FileTransLazyBean event) {
          setState(() {
            logger.d('connLazyWFFileTransEveStm===' + event.toString());
          });
        },
      ),
    );
    _streamSubscriptions.add(
      _blePlugin.lazyEcgEveStm.listen(
        (event) {
          setState(() {
            logger.d('connLazyEcgEveStm===' + event.ints.toString());
          });
        },
      ),
    );
    //以下是李宝忠的监听
    _streamSubscriptions.add(
      _blePlugin.lazyContactAvatarEveStm.listen(
        (FileTransLazyBean event) {
          setState(() {
            logger.d('connLazyContactAvatarEveStm===' + event.toString());
          });
        },
      ),
    );
    //余诗霞：end

    _streamSubscriptions.add(
      _blePlugin.movementStateEveStm.listen(
        (event) {
          setState(() {
            logger.d("connTainStateEveStm======" + event.toString());
          });
        },
      ),
    );

    _streamSubscriptions.add(
      _blePlugin.tempChangeEveStm.listen(
        (TempChangeBean event) {
          setState(() {
            logger.d("connTempChangeEveStm======" + event.toString());
          });
        },
      ),
    );

    _streamSubscriptions.add(
      _blePlugin.contactEveStm.listen(
        (ContactListenBean event) {
          setState(() {
            logger.d("connContactEveStm======" + event.toString());
          });
        },
      ),
    );

    _streamSubscriptions.add(
      _blePlugin.batterySavingEveStm.listen(
        (event) {
          setState(() {
            logger.d("connBatterySavingEveStm======" + event.toString());
          });
        },
      ),
    );

    _streamSubscriptions.add(
      _blePlugin.trainingEveStm.listen(
        (TrainBean event) {
          setState(() {
            logger.d("connTrainingEveStm======" + event.toString());
          });
        },
      ),
    );
  }

  @override
  void dispose() {
    super.dispose();
    for (final subscription in _streamSubscriptions) {
      subscription.cancel();
    }
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Center(
          child: ListView(
            children: <Widget>[
              ElevatedButton(
                  onPressed: () => Navigator.pop(context),
                  child: const Text("返回")),
              Text(device.name + ',' + device.address),

              Text("StepsChange=" + _connStepChange.stepInfo.steps.toString()),

              Text('connetionState= $_connetionState'),

              ElevatedButton(
                  child: const Text('isConnected()'),
                  onPressed: () {
                    _blePlugin.isConnected(device.address);
                  }),
              ElevatedButton(
                  child: const Text("connect()"),
                  onPressed: () {
                    _blePlugin.connect(device.address);
                    isConn = true;
                  }),
              ElevatedButton(
                  child: const Text('disconnect()'),
                  onPressed: () {
                    isConn = false;
                    _blePlugin.disconnect;
                  }),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return TimePage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("Time")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return FirmwarePage(
                              blePlugin: _blePlugin,
                              device: device,
                            );
                          }));
                    }
                  },
                  child: const Text("Firmware")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return BatteryPage(
                              blePlugin: _blePlugin,
                            );
                          })
                      );
                    }
                  },
                  child: const Text("Battery")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return UserInfoPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("UserInfo")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return WeatherPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("Weather")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return StepsPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("Steps")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return SleepPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("Sleep")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return UnitSystemPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("UnitSystem")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return QuickViewPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("QuickView")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return GoalStepsPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("GoalSteps")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return WatchFacePage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("WatchFace")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return AlarmPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("Alarm")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return LanguagePage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("Language")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return NotificationPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("Notification")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return SedentaryReminderPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("SedentaryReminder")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return FindWatchPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("FindWatch")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return HearRatePage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("Hearate")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return BloodPressurePage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("BloodPressure")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return BloodOxygenPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("BloodOxygen")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return TakePhotoPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("TakePhoto")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return RSSIPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("RSSI")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return ShutDownPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("ShutDown")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return NotDisturbPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("NotDisturb")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return BreathingLightPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("BreathingLight")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return ECGPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("ECG")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return MenstrualCyclePage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("MenstrualCycle")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return FindPhonePage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("FindPhone")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return MusicPlayerPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("MusicPlayer")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return DrinkWaterReminderPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("DrinkWaterReminder")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return HeartRateAlarmPage(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("HeartRateAlarm")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return Xulei(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("许蕾页面")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return Yusixia(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("余诗霞页面")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return Lbz(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("李宝忠页面"))
              // libaozhong: end
            ],
          ),
        ),
      ),
    );
  }
}
