import 'package:flutter/material.dart';
import 'package:moyoung_ble_plugin/moyoung_ble.dart';

class TimePage extends StatefulWidget {
  MoYoungBle blePlugin;

  TimePage({
    Key? key,
    required this.blePlugin,
  }) : super(key: key);

  @override
  State<TimePage> createState() {
    return _timePage(blePlugin);
  }
}

class _timePage extends State<TimePage> {
  final MoYoungBle _blePlugin;

  _timePage(this._blePlugin);

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
        home: Scaffold(
            appBar: AppBar(
              title: const Text("TimePage"),
            ),
            body: Center(child: ListView(children: <Widget>[
              ElevatedButton(
                  onPressed: () => _blePlugin.startMovement(10),
                  child: const Text("startMovement()")),
              ElevatedButton(
                  onPressed: () =>
                      _blePlugin.setMovementState(
                          MovementHeartRateStateType.MOVEMENT_COMPLETE),
                  child: const Text("setMaxHeartRate(-1)")),
              ElevatedButton(
                  onPressed: () =>
                      _blePlugin.setMovementState(
                          MovementHeartRateStateType.MOVEMENT_CONTINUE),
                  child: const Text("setMaxHeartRate(-2)")),
              ElevatedButton(
                  onPressed: () =>
                      _blePlugin.setMovementState(
                          MovementHeartRateStateType.MOVEMENT_PAUSE),
                  child: const Text("setMaxHeartRate(-3)")),
            ])
            )
        )
    );
  }
}
