import 'package:flutter/material.dart';
import 'package:moyoung_ble_plugin/moyoung_ble.dart';

class StepsPage extends StatefulWidget {
  MoYoungBle blePlugin;

  StepsPage({
    Key? key,
    required this.blePlugin
  }) : super(key: key);

  @override
  State<StepsPage> createState() {
    return _stepsPage(blePlugin);
  }
}

class _stepsPage extends State<StepsPage> {
  final MoYoungBle _blePlugin;

  _stepsPage(this._blePlugin);

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
        home: Scaffold(
            appBar: AppBar(
              title: const Text("StepsPage"),
            ),
            body: Center(
              child: ListView(
                children: [
                  ElevatedButton(
                      child: const Text('syncStep'),
                      onPressed: () => _blePlugin.syncSteps),
                  ElevatedButton(
                      child: const Text('syncPastStep(YESTERDAY_STEPS)'),
                      onPressed: () => _blePlugin.syncHistorySteps(StepsCategoryDateType.TODAY_STEPS_CATEGORY)),
                  ElevatedButton(
                      child: const Text('queryStepsCategory(CRPStepsCategoryDateType)'),
                      onPressed: () => _blePlugin.queryStepsCategory(StepsCategoryDateType.TODAY_STEPS_CATEGORY)),
                ],
              ),
            )
        )
    );
  }
}
